clear all;
close all;
clc;

load wavelet.mat 
%set up the model (global variables)

global  time dt
global  line_length depth
global  midpoints receivers spacing
global  velocity1 layer 
global  tref wref

dt = 2;          % time sampling interval
time = 0:dt:800;  % time sampling
amplitude = 50;

midpoints = [250 500 750];     % positions of midpoints
receivers = 0:25:1000;    % positions of 41 receivers
depth = 500;

line_length = receivers(end);                 % total length of seismic line
spacing = line_length/(length(receivers)-1);  % receiver spacing

% Rask 1: calculate source-receiver offsets for each midpoint.
% As in a real seismic survey, source and receiver positions and offsets 
% must be determined before acquiring any data.

% Complete the code below.
% The offsets should be stored in a matrix. Each row should correspond to a
% midpoint, and columns correspond to receiver positions.

% First uncomment (delete '%') and then fill the inside the () with correct code.

% for i=1:length(midpoints)
%   offsets(i,:) = 2*();
% end

% Task 2: create three reflecting boundaries 

% When running this script for the first time, keep the following line 'load ...'
% commented out and pick the three layers interactively using 'picklayer'.
% Next time, you can uncomment this 'load ...' (delete the '%')
% and comment out the interactive commands

% load layers.mat

layer1 = picklayer(line_length,depth);
layer2 = picklayer(line_length,depth,layer1);
layer3 = picklayer(line_length,depth,layer1,layer2);

% save the picked layers:
save layers.mat layer*

% Task 3: calculate a synthetic CMP section with three reflectopions

% In matrix variables sec1, sec2, and sec3 below,
% model reflections from each boundary with different stacking velocities.

% You should complete the following three lines.
% First, uncomment each line and then fill in function parameters
% inside of the () as explained in the lab 
% and in the header of reflection_CMP.m file

cmp = 2;      % number of midpoint with which we will work further
              % Use this name 'cmp' and do not specific number in your code
              % (so that you can easily switch to looking at another CMP)  

% sec1 = reflection_CMP();
% sec2 = reflection_CMP();
% sec3 = reflection_CMP();

% sum the records to obtain a simulated reflection section

section=sec1+sec2+sec3;

% plot the partial sec's and the complete section to compare how they look

figure (1);
subplot(1,2,1);
plot_section(offsets(cmp,:),sec1,'offset(m)','b-')
plot_section(offsets(cmp,:),sec2,'offset(m)','r-')
plot_section(offsets(cmp,:),sec3,'offset(m)','g-')

subplot(1,2,2);
plot_section(offsets(cmp,:),section,'offset(m)','b-')

% save the entire workspace

save model1.mat * 

